import time

from cpl_discord.service import DiscordBotServiceABC
from cpl_translation import TranslatePipe
from selenium import webdriver
from selenium.common import NoSuchElementException, StaleElementReferenceException
from selenium.webdriver import Keys
from selenium.webdriver.common.by import By
from selenium.webdriver.remote.webelement import WebElement
from selenium.webdriver.support import expected_conditions
from selenium.webdriver.support.wait import WebDriverWait

from ui_tests_shared.test_case_with_app import TestCaseWithApp


class CommandTestCaseWithApp(TestCaseWithApp):
    _cmd: WebElement

    _bot = None
    _t = None

    @classmethod
    def setUpClass(cls):
        TestCaseWithApp.setUpClass()
        cls._bot = cls._services.get_service(DiscordBotServiceABC)
        cls._t = cls._services.get_service(TranslatePipe)

    def send_command(self, cmd: str):
        self._driver.get('https://discord.com/channels/910199451145076828/911578636899987526')
        time.sleep(2)

        cmd_element_ident = (By.XPATH, '/html/body/div[1]/div[2]/div/div[1]/div/div[2]/div/div[1]/div/div/div[3]/div[2]/main/form/div/div[1]/div/div[3]/div/div[2]/div')
        cmd_element = self._driver.find_element(*cmd_element_ident)
        cmd_element.send_keys(f'/{cmd}')
        time.sleep(2)

        ignored_exceptions = (NoSuchElementException, StaleElementReferenceException,)
        WebDriverWait(self._driver, 20, ignored_exceptions=ignored_exceptions).until(
            expected_conditions.presence_of_element_located((
                By.XPATH,
                '/html/body/div[1]/div[2]/div/div[1]/div/div[2]/div/div[1]/div/div/div[3]/div[2]/main/form/div/div[2]/div/div/div[5]'
            ))
        ).click()
        time.sleep(2)
        self._driver.find_element(By.XPATH, '/html/body/div[1]/div[2]/div/div[1]/div/div[2]/div/div[1]/div/div/div[3]/div/main/form/div/div[2]/div/div[2]/div/div').send_keys(
            Keys.ENTER)
